/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Timer.xs. Do not edit this file, edit Timer.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/POSIX/RT/Timer.xs"
/*
 * This software is copyright (c) 2010 by Leon Timmermans <leont@cpan.org>.
 *
 * This is free software; you can redistribute it and/or modify it under
 * the same terms as perl itself.
 *
 */

#define PERL_NO_GET_CONTEXT
#define PERL_REENTR_API 1

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#define NEED_mg_findext
#include "ppport.h"

#include <signal.h>
#include <time.h>

#define die_sys(format) Perl_croak(aTHX_ format, strerror(errno))

typedef struct { const char* key; STRLEN key_length; clockid_t value; } map[];

static map clocks = {
	{ STR_WITH_LEN("realtime") , CLOCK_REALTIME  }
#ifdef CLOCK_REALTIME_COARSE
	, { STR_WITH_LEN("realtime_coarse"), CLOCK_REALTIME_COARSE }
#endif
#ifdef CLOCK_REALTIME_ALARM
	, { STR_WITH_LEN("realtime_alarm"), CLOCK_REALTIME_ALARM }
#endif
#ifdef CLOCK_MONOTONIC
	, { STR_WITH_LEN("monotonic"), CLOCK_MONOTONIC }
#elif defined CLOCK_HIGHRES
	, { STR_WITH_LEN("monotonic"), CLOCK_HIGHRES }
#endif
#ifdef CLOCK_MONOTONIC_RAW
	, { STR_WITH_LEN("monotonic_raw"), CLOCK_MONOTONIC_RAW }
#endif
#ifdef CLOCK_MONOTONIC_COARSE
	, { STR_WITH_LEN("monotonic_coarse"), CLOCK_MONOTONIC_COARSE }
#endif
#ifdef CLOCK_PROCESS_CPUTIME_ID
	, { STR_WITH_LEN("process"), CLOCK_PROCESS_CPUTIME_ID }
#elif defined CLOCK_PROF
	, { STR_WITH_LEN("process"), CLOCK_PROF }
#endif
#ifdef CLOCK_THREAD_CPUTIME_ID
	, { STR_WITH_LEN("thread"), CLOCK_THREAD_CPUTIME_ID }
#endif
#ifdef CLOCK_UPTIME
	, { STR_WITH_LEN("uptime"), CLOCK_UPTIME }
#endif
#ifdef CLOCK_BOOTTIME
	, { STR_WITH_LEN("boottime"), CLOCK_BOOTTIME }
#endif
#ifdef CLOCK_BOOTTIME_ALARM
	, { STR_WITH_LEN("boottime_alarm"), CLOCK_BOOTTIME_ALARM }
#endif
#ifdef CLOCK_VIRTUAL
	, { STR_WITH_LEN("virtual"), CLOCK_VIRTUAL }
#endif
#ifdef CLOCK_TAI
	, { STR_WITH_LEN("tai"), CLOCK_TAI }
#endif
};

static clockid_t S_get_clockid(pTHX_ SV* clock_name) {
	int i;
	STRLEN length;
	const char* clock_ptr = SvPV(clock_name, length);
	for (i = 0; i < sizeof clocks / sizeof *clocks; ++i) {
		if (clocks[i].key_length == length && strEQ(clock_ptr, clocks[i].key))
			return clocks[i].value;
	}
	Perl_croak(aTHX_ "No such timer '%s' known", SvPV_nolen(clock_name));
}
#define get_clockid(name) S_get_clockid(aTHX_ name)

#define NANO_SECONDS 1000000000

static NV timespec_to_nv(struct timespec* time) {
	return time->tv_sec + time->tv_nsec / (double)NANO_SECONDS;
}

static void nv_to_timespec(NV input, struct timespec* output) {
	output->tv_sec  = (time_t) floor(input);
	output->tv_nsec = (long) ((input - output->tv_sec) * NANO_SECONDS);
}

#if defined(SIGEV_THREAD_ID) && defined(SYS_gettid)
#include <sys/syscall.h>
#define gettid() syscall(SYS_gettid)
#ifndef sigev_notify_thread_id
#define sigev_notify_thread_id   _sigev_un._tid
#endif
#endif

#if defined(_POSIX_CLOCK_SELECTION) && _POSIX_CLOCK_SELECTION >= 0
static int my_clock_nanosleep(pTHX_ clockid_t clockid, int flags, const struct timespec* request, struct timespec* remain) {
	int ret;
	ret = clock_nanosleep(clockid, flags, request, remain);
	if (ret != 0) {
		errno = ret;
		if (ret != EINTR)
			die_sys("Could not sleep: %s");
	}
	return ret;
}
#endif

#define clock_nanosleep(clockid, flags, request, remain) my_clock_nanosleep(aTHX_ clockid, flags, request, remain)

#if defined(USE_ITHREADS) && defined(_POSIX_THREAD_CPUTIME) && _POSIX_THREAD_CPUTIME >= 0
static pthread_t* S_get_pthread(pTHX_ SV* thread_handle) {
	SV* tmp;
	pthread_t* ret;
	dSP;
	ENTER;
	SAVETMPS;
	PUSHMARK(SP);
	PUSHs(thread_handle);
	PUTBACK;
	call_method("_handle", G_SCALAR);
	SPAGAIN;
	tmp = POPs;
	ret = INT2PTR(pthread_t* ,SvUV(tmp));
	FREETMPS;
	LEAVE;
	return ret;
}
#define get_pthread(handle) S_get_pthread(aTHX_ handle)
#endif

#define undef &PL_sv_undef

typedef struct _timer_init {
	clockid_t clockid;
	IV signo;
	IV ident;
	struct itimerspec itimer;
	int flags;
} timer_init;

static void S_timer_init_gather(pTHX_ timer_init* result, SV** begin, size_t items) {
	int i;
	Zero(result, 1, timer_init);
	result->clockid = CLOCK_REALTIME;
	for(i = 0; i < items; i += 2) {
		const char* current;
		STRLEN curlen;
		SV *key = begin[i], *value = begin[i+1];
		current = SvPV(key, curlen);
		if (curlen == 5) {
			if (strEQ(current, "clock"))
				result->clockid = SvROK(value) ? SvUV(SvRV(value)) : get_clockid(value);
			else if (strEQ(current, "value"))
				nv_to_timespec(SvNV(value), &result->itimer.it_value);
			else if (strEQ(current, "ident"))
				result->ident = SvIV(value);
			else
				goto fail;
		}
		else if (curlen == 6 && strEQ(current, "signal"))
			result->signo = (SvIOK(value) || looks_like_number(value)) ? SvIV(value) : whichsig(SvPV_nolen(value));
		else if (curlen == 8) {
			if (strEQ(current, "interval"))
				nv_to_timespec(SvNV(value), &result->itimer.it_interval);
			else if (strEQ(current, "absolute"))
				result->flags |= TIMER_ABSTIME;
			else
				goto fail;
		}
		else
			fail: Perl_croak(aTHX_ "Unknown option '%s'", current);
	}
}
#define timer_init_gather(init, begin, items) S_timer_init_gather(aTHX_ init, begin, items)

static timer_t S_timer_new(pTHX_ timer_init* para) {
	timer_t timer;
	struct sigevent event = { 0 };

	if (para->signo < 0)
		Perl_croak(aTHX_ "No valid signal was given");

#ifdef gettid
	event.sigev_notify           = SIGEV_THREAD_ID;
	event.sigev_notify_thread_id = gettid();
#else
	event.sigev_notify           = SIGEV_SIGNAL;
#endif
	event.sigev_signo            = para->signo;
	event.sigev_value.sival_int  = para->ident;

	if (timer_create(para->clockid, &event, &timer) < 0)
		die_sys("Couldn't create timer: %s");
	if (timer_settime(timer, para->flags, &para->itimer, NULL) < 0)
		die_sys("Couldn't set_time: %s");

	return timer;
}
#define timer_new(para) S_timer_new(aTHX_ para)

void timespec_add(struct timespec* left, const struct timespec* right) {
	left->tv_sec += right->tv_sec;
	left->tv_nsec += right->tv_nsec;
	while (left->tv_nsec > 1000000000) {
		left->tv_nsec -= 1000000000;
		left->tv_sec++;
	}
}

static const struct timespec no_time = { 0, 0 };

typedef timer_t POSIX__RT__Timer;
typedef clockid_t POSIX__RT__Clock;

#define XS_unpack_clockid_t(sv) get_clockid(sv)

#line 232 "lib/POSIX/RT/Timer.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 376 "lib/POSIX/RT/Timer.c"

XS_EUPXS(XS_POSIX__RT__Timer_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Timer_new)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "class, args, ...");
    {
	POSIX__RT__Timer	RETVAL;
	SV *	class = ST(0)
;
	timer_init	args;

	timer_init_gather(&args, &ST(1), items - 1)
;
#line 228 "lib/POSIX/RT/Timer.xs"
		RETVAL = timer_new(&args);
#line 394 "lib/POSIX/RT/Timer.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
		    sv_setref_uv(RETVALSV, "POSIX::RT::Timer", (UV)RETVAL);
		    SvREADONLY_on(SvRV(RETVALSV));
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_POSIX__RT__Timer_handle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Timer_handle)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "timer");
    {
	UV	RETVAL;
	dXSTARG;
	POSIX__RT__Timer	timer;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "POSIX::RT::Timer"))
			timer = (POSIX__RT__Timer)SvUV(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "POSIX::RT::Timer::handle", "timer", "POSIX::RT::Timer");
    }
;
#line 234 "lib/POSIX/RT/Timer.xs"
		RETVAL = (UV)timer;
#line 430 "lib/POSIX/RT/Timer.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_POSIX__RT__Timer_get_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Timer_get_timeout)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "timer");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 240 "lib/POSIX/RT/Timer.xs"
		struct itimerspec value;
#line 449 "lib/POSIX/RT/Timer.c"
	POSIX__RT__Timer	timer;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "POSIX::RT::Timer"))
			timer = (POSIX__RT__Timer)SvUV(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "POSIX::RT::Timer::get_timeout", "timer", "POSIX::RT::Timer");
    }
;
#line 242 "lib/POSIX/RT/Timer.xs"
		if (timer_gettime(timer, &value) == -1)
			die_sys("Couldn't get_time: %s");
		mXPUSHn(timespec_to_nv(&value.it_value));
		if (GIMME_V == G_ARRAY)
			mXPUSHn(timespec_to_nv(&value.it_interval));
#line 466 "lib/POSIX/RT/Timer.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_POSIX__RT__Timer_set_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Timer_set_timeout)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "timer, new_value, new_interval= no_time, abstime= FALSE");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 250 "lib/POSIX/RT/Timer.xs"
		struct itimerspec old_itimer;
#line 484 "lib/POSIX/RT/Timer.c"
	POSIX__RT__Timer	timer;
	struct timespec	new_value;
	struct timespec	new_interval;
	bool	abstime;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "POSIX::RT::Timer"))
			timer = (POSIX__RT__Timer)SvUV(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "POSIX::RT::Timer::set_timeout", "timer", "POSIX::RT::Timer");
    }
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Time::Spec")) {
		new_value = *(struct timespec*)SvPV_nolen(SvRV(ST(1)));
	} else {
		NV input = SvNV(ST(1));
		new_value.tv_sec  = (time_t) floor(input);
		new_value.tv_nsec = (long) ((input - new_value.tv_sec) * 1000000000);
	}
;

	if (items < 3)
	    new_interval = no_time;
	else {
	    if (SvROK(ST(2)) && sv_derived_from(ST(2), "Time::Spec")) {
		    new_interval = *(struct timespec*)SvPV_nolen(SvRV(ST(2)));
	    } else {
		    NV input = SvNV(ST(2));
		    new_interval.tv_sec  = (time_t) floor(input);
		    new_interval.tv_nsec = (long) ((input - new_interval.tv_sec) * 1000000000);
	    }
;
	}

	if (items < 4)
	    abstime = FALSE;
	else {
	    abstime = (bool)SvTRUE(ST(3))
;
	}
#line 252 "lib/POSIX/RT/Timer.xs"
		struct itimerspec new_itimer = { new_value, new_interval };
		if (timer_settime(timer, (abstime ? TIMER_ABSTIME : 0), &new_itimer, &old_itimer) == -1)
			die_sys("Couldn't set_time: %s");
		mXPUSHn(timespec_to_nv(&old_itimer.it_value));
		if (GIMME_V == G_ARRAY)
			mXPUSHn(timespec_to_nv(&old_itimer.it_interval));
#line 534 "lib/POSIX/RT/Timer.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_POSIX__RT__Timer_get_overrun); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Timer_get_overrun)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "timer");
    {
	IV	RETVAL;
	dXSTARG;
	POSIX__RT__Timer	timer;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "POSIX::RT::Timer"))
			timer = (POSIX__RT__Timer)SvUV(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "POSIX::RT::Timer::get_overrun", "timer", "POSIX::RT::Timer");
    }
;
#line 261 "lib/POSIX/RT/Timer.xs"
		RETVAL = timer_getoverrun(timer);
		if (RETVAL == -1) 
			die_sys("Couldn't get_overrun: %s");
#line 564 "lib/POSIX/RT/Timer.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_POSIX__RT__Timer_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Timer_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "timer");
    {
	POSIX__RT__Timer	timer;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && SvIOK(SvRV(sv)))
			timer = (POSIX__RT__Timer)SvUV(SvRV(sv));
		else
			croak("%s: %s is not a reference", "POSIX::RT::Timer::DESTROY", "timer");
    }
;
#line 269 "lib/POSIX/RT/Timer.xs"
		timer_delete(timer);
#line 591 "lib/POSIX/RT/Timer.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_POSIX__RT__Clock_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Clock_new)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "class, clockid= CLOCK_REALTIME");
    {
	POSIX__RT__Clock	RETVAL;
	SV *	class = ST(0)
;
	clockid_t	clockid;

	if (items < 2)
	    clockid = CLOCK_REALTIME;
	else {
	    clockid = XS_unpack_clockid_t(ST(1))
;
	}
#line 277 "lib/POSIX/RT/Timer.xs"
		RETVAL = clockid;
#line 617 "lib/POSIX/RT/Timer.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
		    sv_setref_uv(RETVALSV, "POSIX::RT::Clock", (UV)RETVAL);
		    SvREADONLY_on(SvRV(RETVALSV));
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_POSIX__RT__Clock_handle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Clock_handle)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "clock");
    {
	UV	RETVAL;
	dXSTARG;
	POSIX__RT__Clock	clock;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "POSIX::RT::Clock"))
			clock = (POSIX__RT__Clock)SvUV(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "POSIX::RT::Clock::handle", "clock", "POSIX::RT::Clock");
    }
;
#line 283 "lib/POSIX/RT/Timer.xs"
		RETVAL = (UV)clock;
#line 653 "lib/POSIX/RT/Timer.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}

#if defined(_POSIX_CPUTIME) && _POSIX_CPUTIME >= 0
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_POSIX__RT__Clock_get_cpuclock); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Clock_get_cpuclock)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "class, pid= undef");
    {
	POSIX__RT__Clock	RETVAL;
	SV *	class = ST(0)
;
	SV *	pid;

	if (items < 2)
	    pid = undef;
	else {
	    pid = ST(1)
;
	}
#line 290 "lib/POSIX/RT/Timer.xs"
		if (SvOK(pid) && SvROK(pid) && sv_derived_from(pid, "threads")) {
#if defined(USE_ITHREADS) && defined(_POSIX_THREAD_CPUTIME) && _POSIX_THREAD_CPUTIME >= 0
			pthread_t* handle = get_pthread(pid);
			if (pthread_getcpuclockid(*handle, &RETVAL) != 0)
				die_sys("Could not get cpuclock: %s");
#else
			Perl_croak(aTHX_ "Can't get CPU time for threads");
#endif
		}
		else {
			if (clock_getcpuclockid(SvOK(pid) ? SvIV(pid) : 0, &RETVAL) != 0)
				die_sys("Could not get cpuclock: %s");
		}
#line 696 "lib/POSIX/RT/Timer.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
		    sv_setref_uv(RETVALSV, "POSIX::RT::Clock", (UV)RETVAL);
		    SvREADONLY_on(SvRV(RETVALSV));
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_POSIX__RT__Clock_get_clocks); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Clock_get_clocks)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 310 "lib/POSIX/RT/Timer.xs"
		size_t i;
		const size_t max = sizeof clocks / sizeof *clocks;
#line 724 "lib/POSIX/RT/Timer.c"
#line 313 "lib/POSIX/RT/Timer.xs"
		for (i = 0; i < max; ++i)
			mXPUSHp(clocks[i].key, clocks[i].key_length);
		PUTBACK;
#line 729 "lib/POSIX/RT/Timer.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_POSIX__RT__Clock_get_time); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Clock_get_time)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "clockid");
    {
	struct timespec	RETVAL;
	dXSTARG;
	POSIX__RT__Clock	clockid;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "POSIX::RT::Clock"))
			clockid = (POSIX__RT__Clock)SvUV(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "POSIX::RT::Clock::get_time", "clockid", "POSIX::RT::Clock");
    }
;
#line 319 "lib/POSIX/RT/Timer.xs"
		if (clock_gettime(clockid, &RETVAL) == -1)
			die_sys("Couldn't get time: %s");
#line 758 "lib/POSIX/RT/Timer.c"
	XSprePUSH;
	PUSHn(RETVAL.tv_sec + RETVAL.tv_nsec / 1000000000.0);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_POSIX__RT__Clock_set_time); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Clock_set_time)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "clockid, time");
    {
	POSIX__RT__Clock	clockid;
	struct timespec	time;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "POSIX::RT::Clock"))
			clockid = (POSIX__RT__Clock)SvUV(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "POSIX::RT::Clock::set_time", "clockid", "POSIX::RT::Clock");
    }
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Time::Spec")) {
		time = *(struct timespec*)SvPV_nolen(SvRV(ST(1)));
	} else {
		NV input = SvNV(ST(1));
		time.tv_sec  = (time_t) floor(input);
		time.tv_nsec = (long) ((input - time.tv_sec) * 1000000000);
	}
;
#line 326 "lib/POSIX/RT/Timer.xs"
		if (clock_settime(clockid, &time) == -1)
			die_sys("Couldn't set time: %s");
#line 796 "lib/POSIX/RT/Timer.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_POSIX__RT__Clock_get_resolution); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Clock_get_resolution)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "clockid");
    {
	struct timespec	RETVAL;
	dXSTARG;
	POSIX__RT__Clock	clockid;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "POSIX::RT::Clock"))
			clockid = (POSIX__RT__Clock)SvUV(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "POSIX::RT::Clock::get_resolution", "clockid", "POSIX::RT::Clock");
    }
;
#line 331 "lib/POSIX/RT/Timer.xs"
		if (clock_getres(clockid, &RETVAL) == -1)
			die_sys("Couldn't get resolution: %s");
#line 824 "lib/POSIX/RT/Timer.c"
	XSprePUSH;
	PUSHn(RETVAL.tv_sec + RETVAL.tv_nsec / 1000000000.0);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_POSIX__RT__Clock_timer); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Clock_timer)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "clockid, args, ...");
    {
	POSIX__RT__Timer	RETVAL;
	POSIX__RT__Clock	clockid;
	timer_init	args;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "POSIX::RT::Clock"))
			clockid = (POSIX__RT__Clock)SvUV(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "POSIX::RT::Clock::timer", "clockid", "POSIX::RT::Clock");
    }
;

	timer_init_gather(&args, &ST(1), items - 1)
;
#line 338 "lib/POSIX/RT/Timer.xs"
		args.clockid = clockid;
		RETVAL = timer_new(&args);
#line 857 "lib/POSIX/RT/Timer.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
		    sv_setref_uv(RETVALSV, "POSIX::RT::Timer", (UV)RETVAL);
		    SvREADONLY_on(SvRV(RETVALSV));
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#if defined(_POSIX_CLOCK_SELECTION) && _POSIX_CLOCK_SELECTION >= 0
#define XSubPPtmpAAAB 1


XS_EUPXS(XS_POSIX__RT__Clock_sleep); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Clock_sleep)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "clockid, time, abstime= FALSE");
    {
#line 346 "lib/POSIX/RT/Timer.xs"
		struct timespec remain_time;
		int flags;
#line 885 "lib/POSIX/RT/Timer.c"
	struct timespec	RETVAL;
	dXSTARG;
	POSIX__RT__Clock	clockid;
	struct timespec	time;
	bool	abstime;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "POSIX::RT::Clock"))
			clockid = (POSIX__RT__Clock)SvUV(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "POSIX::RT::Clock::sleep", "clockid", "POSIX::RT::Clock");
    }
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Time::Spec")) {
		time = *(struct timespec*)SvPV_nolen(SvRV(ST(1)));
	} else {
		NV input = SvNV(ST(1));
		time.tv_sec  = (time_t) floor(input);
		time.tv_nsec = (long) ((input - time.tv_sec) * 1000000000);
	}
;

	if (items < 3)
	    abstime = FALSE;
	else {
	    abstime = (bool)SvTRUE(ST(2))
;
	}
#line 349 "lib/POSIX/RT/Timer.xs"
		flags = abstime ? TIMER_ABSTIME : 0;

		if (clock_nanosleep(clockid, flags, &time, &remain_time) == EINTR)
			RETVAL = abstime ? time : remain_time;
		else 
			RETVAL = no_time;
#line 923 "lib/POSIX/RT/Timer.c"
	XSprePUSH;
	PUSHn(RETVAL.tv_sec + RETVAL.tv_nsec / 1000000000.0);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_POSIX__RT__Clock_sleep_deeply); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Clock_sleep_deeply)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "clockid, time, abstime= FALSE");
    {
#line 360 "lib/POSIX/RT/Timer.xs"
#line 939 "lib/POSIX/RT/Timer.c"
	NV	RETVAL;
	dXSTARG;
	POSIX__RT__Clock	clockid;
	struct timespec	time;
	bool	abstime;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "POSIX::RT::Clock"))
			clockid = (POSIX__RT__Clock)SvUV(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "POSIX::RT::Clock::sleep_deeply", "clockid", "POSIX::RT::Clock");
    }
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Time::Spec")) {
		time = *(struct timespec*)SvPV_nolen(SvRV(ST(1)));
	} else {
		NV input = SvNV(ST(1));
		time.tv_sec  = (time_t) floor(input);
		time.tv_nsec = (long) ((input - time.tv_sec) * 1000000000);
	}
;

	if (items < 3)
	    abstime = FALSE;
	else {
	    abstime = (bool)SvTRUE(ST(2))
;
	}
#line 361 "lib/POSIX/RT/Timer.xs"
		if (!abstime) {
			struct timespec current_time;
			if (clock_gettime(clockid, &current_time) == -1)
				die_sys("Couldn't get time: %s");
			timespec_add(&time, &current_time);
		}
		while (clock_nanosleep(clockid, TIMER_ABSTIME, &time, NULL) == EINTR);
		RETVAL = 0;
#line 979 "lib/POSIX/RT/Timer.c"
	XSprePUSH;
	PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}

#endif
#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_POSIX__RT__Timer); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_POSIX__RT__Timer)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("POSIX::RT::Timer::new", XS_POSIX__RT__Timer_new);
        newXS_deffile("POSIX::RT::Timer::handle", XS_POSIX__RT__Timer_handle);
        newXS_deffile("POSIX::RT::Timer::get_timeout", XS_POSIX__RT__Timer_get_timeout);
        newXS_deffile("POSIX::RT::Timer::set_timeout", XS_POSIX__RT__Timer_set_timeout);
        newXS_deffile("POSIX::RT::Timer::get_overrun", XS_POSIX__RT__Timer_get_overrun);
        newXS_deffile("POSIX::RT::Timer::DESTROY", XS_POSIX__RT__Timer_DESTROY);
        newXS_deffile("POSIX::RT::Clock::new", XS_POSIX__RT__Clock_new);
        newXS_deffile("POSIX::RT::Clock::handle", XS_POSIX__RT__Clock_handle);
#if XSubPPtmpAAAA
        newXS_deffile("POSIX::RT::Clock::get_cpuclock", XS_POSIX__RT__Clock_get_cpuclock);
#endif
        newXS_deffile("POSIX::RT::Clock::get_clocks", XS_POSIX__RT__Clock_get_clocks);
        newXS_deffile("POSIX::RT::Clock::get_time", XS_POSIX__RT__Clock_get_time);
        newXS_deffile("POSIX::RT::Clock::set_time", XS_POSIX__RT__Clock_set_time);
        newXS_deffile("POSIX::RT::Clock::get_resolution", XS_POSIX__RT__Clock_get_resolution);
        newXS_deffile("POSIX::RT::Clock::timer", XS_POSIX__RT__Clock_timer);
#if XSubPPtmpAAAB
        newXS_deffile("POSIX::RT::Clock::sleep", XS_POSIX__RT__Clock_sleep);
        newXS_deffile("POSIX::RT::Clock::sleep_deeply", XS_POSIX__RT__Clock_sleep_deeply);
#endif

    /* Initialisation Section */

#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAB
#endif
#line 1042 "lib/POSIX/RT/Timer.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
